
_G.BlackMarketModsRows = _G.BlackMarketModsRows or {}
BlackMarketModsRows.ModPath = ModPath
BlackMarketModsRows.SaveFilePath = SavePath .. "BlackMarketModsRows.json"
BlackMarketModsRows.JsonOptionsPath = ModPath .. "menu/modoptions.json"
BlackMarketModsRows.data = {}


function BlackMarketModsRows:Save()
	local file = io.open( self.SaveFilePath, "w+" )
	if file then
		file:write( json.encode( self.data ) )
		file:close()
	end
end


function BlackMarketModsRows:Load()
	local file = io.open( self.SaveFilePath, "r" )
	if file then
    	decoded_data = json.decode( file:read("*all") )
		for k,v in pairs(decoded_data) do BlackMarketModsRows.data[k] = v end
		file:close()
	end
end


function BlackMarketModsRows:LoadDefaults()
	-- sets default vals in .data with default_value from menujson  
	local file = io.open(self.JsonOptionsPath, "r")
	if file then
		local file_content = file:read("*all")
		file:close()
        local content = json.decode(file_content)
		local items = content.items

        for _ , item in pairs(items) do
            self.data[item.value] = item.default_value
        end
    end
end

BlackMarketModsRows:LoadDefaults()


-- Taken from Lobby Player Info mod by TdlQ
Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_BlackMarketModsRows", function(loc)
    for __, filename in pairs(file.GetFiles(BlackMarketModsRows.ModPath .. "loc/")) do
            local str = filename:match('^(.*).txt$')
            if str and Idstring(str) and Idstring(str):key() == SystemInfo:language():key() then
                    loc:load_localization_file(BlackMarketModsRows.ModPath .. "loc/" .. filename)
                    break
            end
    end
    loc:load_localization_file(BlackMarketModsRows.ModPath .. "loc/english.txt", false)
end)


--[[
	Setup our menu callbacks, load our saved data, and build the menu from our json file.
]]
Hooks:Add( "MenuManagerInitialize", "MenuManagerInitialize_BlackMarketModsRows", function( menu_manager )
	--Setup our callbacks as defined in our item callback keys, and perform our logic on the data retrieved.
    MenuCallbackHandler.bmmr_callback_save = function(self, item)
		BlackMarketModsRows:Save()
        --log("["..ModPath.."] : settings saved")
	end

	MenuCallbackHandler.callback_rows_multi = function(self, item)
		BlackMarketModsRows.data[item:name()] = item:value()
		--log(" " .. item:value())
	end

	MenuCallbackHandler.mwmr_simple_callback = function(self, item)
		BlackMarketModsRows.data[item:name()] = item:value()
	end

	BlackMarketModsRows:Load()
	MenuHelper:LoadFromJsonFile( BlackMarketModsRows.JsonOptionsPath, BlackMarketModsRows, BlackMarketModsRows.data )
    
end )



function BlackMarketModsRows:get_rows()
	return BlackMarketModsRows.data.rows_menu_multi
end

function BlackMarketModsRows:get_cols()
	return BlackMarketModsRows.data.cols_menu_multi + 3
end

function BlackMarketModsRows:get_mod_height()
	return BlackMarketModsRows.data.mod_item_height / 10
end
