if not BlackMarketModsRows then return end

-- from tdlq
local key = ModPath .. '	' .. RequiredScript
if _G[key] then return else _G[key] = true end   


local function adjust_mod_grid(new_node_data)

	local cols =  BlackMarketModsRows.get_cols()
	local rows = BlackMarketModsRows.get_rows()
	local mod_height  =  BlackMarketModsRows.get_mod_height()

	local WEAPON_MODS_SLOTS = {cols,rows}
	local WEAPON_MODS_GRID_H_MUL = mod_height * WEAPON_MODS_SLOTS[2]
	new_node_data.panel_grid_h_mul = WEAPON_MODS_GRID_H_MUL
	for i, data in ipairs(new_node_data) do
		data.override_slots = WEAPON_MODS_SLOTS
		data.panel_grid_h_mul = WEAPON_MODS_GRID_H_MUL
		data.panel_grid_top_padding = 1 - new_node_data.panel_grid_h_mul
	end

end

--[[ 
local function adjust_weapon_pos()
	if not managers.menu_scene then 
		return 
	end
	local rows = BlackMarketModsRows.get_rows()
	local mod_height  =  BlackMarketModsRows.get_mod_height()
	local mods_h = mod_height * rows
	local menu = managers.menu_scene:get_scene_template_data("blackmarket_crafting")

	-- apparently blackmarket_crafting.item_pos & target_pos has an influence on blackmarket_weapon_color  ... 

	menu.orig_item_pos = menu.orig_item_pos or menu.item_pos
	local weaopn_offset = Vector3(0, 0,0)

	if mods_h < 0.60  then
		weaopn_offset =  Vector3(1, 40 * mods_h ,30 * mods_h)
	else
		weaopn_offset =  Vector3(0, 0 , -5)
	end
	menu.item_pos =  menu.orig_item_pos + weaopn_offset

end

local function reset_weapon_pos()

	if not managers.menu_scene then 
		return 
	end
	local menu = managers.menu_scene:get_scene_template_data("blackmarket_crafting")
	menu.item_pos = menu.orig_item_pos or menu.item_pos
end

]]

Hooks:PreHook(BlackMarketGui, '_start_crafting_weapon', '_start_crafting_weapon_BMMR_balckmk',
function( self , data, new_node_data)
	adjust_mod_grid(new_node_data)
	managers.blackmarket._in_crafting = true
end)

Hooks:PreHook(PlayerInventoryGui, '_start_crafting_weapon', '_start_crafting_weapon_BMMR_playerinv',
function(self,  data, new_node_data)
	adjust_mod_grid(new_node_data)
	managers.blackmarket._in_crafting = true
end)


Hooks:PostHook(BlackMarketGui, 'populate_mods', 'populate_mods_BMMR',
function(self,  data)

	local cols =  BlackMarketModsRows.get_cols()
	local rows = BlackMarketModsRows.get_rows()

	local num_steps = #data.on_create_data
	local n_fully_fill = math.max(math.ceil(num_steps / cols), rows) * cols

	-- from BlackMarketGui:populate_mods  , fills missing items in last row with "empty" smthing otherwise last icons will be visually fucked 
	if n_fully_fill >= #data then
		for i = 1, n_fully_fill do
			if not data[i] then
				new_data = {
					name = "empty",
					name_localized = "",
					category = data.category,
					slot = i,
					unlocked = true,
					equipped = false
				}
				data[i] = new_data
			end
		end
	end
	
	-- removes unnecessary empty mods , if not there could be empy row at bottom 
	if  n_fully_fill < #data then
		for i = #data, n_fully_fill+1 ,-1 do
			data[i] = nil
		end
	end

end)

--[[
weapon pos adjustment 	
 |
 |
\|/

]]
Hooks:PreHook(BlackMarketGui, 'init', 'init_BMMR_BlackMarketGui',
function(self, ws, fullscreen_ws, node)
	--adjust_weapon_pos()
	managers.blackmarket._in_crafting = true
end)

Hooks:PreHook(BlackMarketGui, '_setup', 'init_BMMR_BlackMarketGui',
function(self, ws, fullscreen_ws, node)
	--adjust_weapon_pos()
	managers.blackmarket._in_crafting = true
end)


Hooks:PreHook(BlackMarketGui, 'close', 'close_BMMR_BlackMarketGui',
function(self,  ...)
	--reset_weapon_pos()
	managers.blackmarket._in_crafting = false
end)

Hooks:PreHook(BlackMarketGui, 'open_customize_weapon_color_menu', 'open_customize_weapon_color_menu_BMMR_BlackMarketGui',
function(self,  ...)
	--reset_weapon_pos()
	managers.blackmarket._in_crafting =false
end)


-- Lines 12612-12614
function BlackMarketGui.get_crafting_custom_data()
		local custom_data = managers.menu_scene:get_crafting_custom_data()

		-- this or even current scene do not work , this is called before change to desire scen
		--local active_node = managers.menu:active_menu().renderer:active_node_gui().name
		--log("node : " , active_node )

		if not managers.blackmarket._in_crafting then 
			return custom_data
		end

		
		local rows = BlackMarketModsRows.get_rows()
		local mod_height  =  BlackMarketModsRows.get_mod_height()
		local mods_h = mod_height * rows
		local weaopn_offset = Vector3(0, 0,0)
		
		if mods_h < 0.60  then
			weaopn_offset =  Vector3(-10, 40 * mods_h ,30 * mods_h)
		else
			weaopn_offset =  Vector3(0, 0 , -5)
		end
		
		custom_data.item_pos =  custom_data.item_pos + weaopn_offset
		return custom_data
end

--BlackMarketGui.identifiers.weapon

Hooks:PreHook(MenuNodeCustomizeWeaponColorGui,"close","MenuNodeCustomizeWeaponColorGuicloseeeee",
function(self,...)
	--adjust_weapon_pos()
	managers.blackmarket._in_crafting = true
	local bmm = managers.blackmarket
	--local bmg = managers.menu_component._blackmarket_gui
	--bmm:view_weapon(bmm._preview_blueprint.category, bmm._preview_blueprint.category.slot, function () end, nil, BlackMarketGui.get_crafting_custom_data())

	local category = bmm._preview_blueprint.category
	local slot = bmm._preview_blueprint.slot
	local custom_data = BlackMarketGui.get_crafting_custom_data()
	
	--from "function BlackMarketManager:view_weapon(category, slot, open_node_cb, spawn_workbench, custom_data)"
	if not bmm._global.crafted_items[category] or not bmm._global.crafted_items[category][slot] then
		Application:error("[BlackMarketManager:view_weapon] Trying to view weapon that doesn't exist", category, slot)
		return
	end

	local weapon = bmm._global.crafted_items[category][slot]
	bmm._last_viewed_cosmetic_id = nil
	local texture_switches = bmm:get_weapon_texture_switches(category, slot, weapon)

	bmm:preload_weapon_blueprint("preview", weapon.factory_id, weapon.blueprint, nil)
	-- respawns weapon in new pos 
	managers.menu_scene:spawn_item_weapon(weapon.factory_id, weapon.blueprint, weapon.cosmetics, texture_switches, custom_data)

end)
